/* FindNextWS.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _FINDNEXTWS_IDC_ 
#define _FINDNEXTWS_IDC_

/* args: str - input string
 * returns: index of the next whitespace character
 *         -1 if no whitespace was found
 */
static FindNextWS(str)
{
	auto idx, idx2;
	idx = strlen(str)+1;
	
	idx2 = strstr(str, " ");
	if ((idx2 != -1) && (idx2 < idx))
	{
		idx = idx2;
	}

	idx2 = strstr(str, "\t");
	if ((idx2 != -1) && (idx2 < idx))
	{
		idx = idx2;
	}

	idx2 = strstr(str, "\r");
	if ((idx2 != -1) && (idx2 < idx))
	{
		idx = idx2;
	}
	
	idx2 = strstr(str, "\n");
	if ((idx2 != -1) && (idx2 < idx))
	{
		idx = idx2;
	}

	if (idx == strlen(str)+1)
	{
		/* no whitespace to be found */
		return -1;
	}

	return idx;	
}

#endif