/* MakeCmdStr.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _MAKECMDSTR_IDC_
#define _MAKECMDSTR_IDC_

#include <idcrt\lib\EatLeadWS.idc>
#include <idcrt\lib\EatTailWS.idc>
#include <idcrt\lib\FindNextWS.idc>
	

/* process the argument vectors used by the other process.idc functions */
static MakeCmdStr( argsArray )
{
	auto idx;
	auto cmdStr;
	auto data;
	
	idx = GetFirstIndex(AR_STR, argsArray);
	
	cmdStr = "";
	
	while(idx != -1)
	{
		data = GetArrayElement(AR_STR, argsArray, idx);
		
		if (data != "")
		{
			data = EatLeadWS(data);
			data = EatTailWS(data);

			if (-1 == FindNextWS(data))
			{
				auto len;
				len = strlen(data);
				
				if ((substr(data, 0, 1) != "\"") || (substr(data, len-1, len)!= "\""))
				{
					/* add quotes around the data string */
					data = "\"" + data + "\"";
				}
			}
			
			cmdStr = cmdStr + " " + data;
		}
		
		idx = GetNextIndex(AR_STR, argsArray, idx);
	}
	
	return cmdStr;
}

#endif
