/* ParseWS.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _PARSEWS_IDC_ 
#define _PARSEWS_IDC_

/* Just like EatLeadWS except that it will continue to read from the file until EOF
 * or a non-whitespace character is found
 * args: File - file pointer to the input file
 *       str - the current input string.
 * returns: the input string or a new input line from the file.
 *          In either case all leading whitespace is removed.
 */
static ParseWS(File, str)
{
	auto bDone;
	
	bDone = 0;
	while (bDone == 0)
	{
		str = EatLeadWS(str);
		if (str == "")
		{
			str = readstr(File);
			if (str == "")
			{
				/* detect EOF */
				return "";
			}
		}
		else
		{
			/* there's something left on the string, so stop eating */
			bDone = 1;
		}
	}

	return str;
}

#endif

