/* compactstrarray.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */
 
#ifndef _COMPACTSTRARRAY_IDC_
#define _COMPACTSTRARRAY_IDC_

/* args: array - array of strings to be compacted
 *		 bCutBlanks - flag to cut empty strings
 * returns: The number of elements remaining in the array
 */
static compactstrarray(array, bCutBlanks)
{
	auto dIdx;
	auto sIdx;
	auto tmpStr;
	auto elemCount;
	
	elemCount = 0;
	dIdx = 0;
	sIdx = GetFirstIndex(AR_STR, array);
	
	while (sIdx != -1)
	{
		tmpStr = GetArrayElement(AR_STR, array, sIdx);

		/* only move non-empty strings */
		if ((tmpStr != "") || (!bCutBlanks))
		{
			if (dIdx != sIdx)
			{
				/* we actually have to move the string */
				DelArrayElement(AR_STR, array, sIdx);
				SetArrayString(array, dIdx, tmpStr);
			}

			elemCount = elemCount + 1;
			dIdx = dIdx + 1;
		}
		else
		{
			DelArrayElement(AR_STR, array, sIdx);
		}
		
		sIdx = GetNextIndex(AR_STR, array, sIdx);
	}				
	
	return elemCount;
}

#endif

