/* execv.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _EXECV_IDC_
#define _EXECV_IDC_

#include <idcrt\lib\MakeCmdStr.idc>

/* args: argsArray - User-allocated array containing strings to be concatenated and
 *					 asynchronously executed using 'start'.
 * returns: the OS-returned result from the command line executed
 * NOTES: Arguments that contain spaces will be automatically quoted if they aren't already.
 */
static execv( argsArray )
{
	auto commandLine;
	
	/* concat the arguments */
	commandLine = MakeCmdStr(argsArray);

	/* make it asynch */	
	commandLine = "start " + commandLine;
	
	return Exec(commandLine);
}

#endif

