/* feof.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _FEOF_H_
#define _FEOF_H_

/* args: hFile - open file handle
 * returns: 1 if the file handle is at the end of file
 *			0 if the file handle is not at the end of file
 */
static feof(hFile)
{
	auto curPos;

	curPos = ftell(hFile);
	fseek(hFile, 0, 2);

	if (ftell(hFile) != curPos)
	{
		fseek(hFile, curPos, 0);
		return 0;
	}
	
	return 1;
}

#endif