/* fileexists.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _FILEEXISTS_H_
#define _FILEEXISTS_H_

/* args: filename - name of a file that may exist in the current directory
 * returns: 1 if the file exists
 *			0 if the file doesn't exist
 */
static fileexists(filename)
{
	auto tmpFile;
	
	tmpFile = fopen(filename, "r");
	fclose(tmpFile);
	
	if (tmpFile == 0)
	{
		return 0;
	}
	
	return 1;
}

#endif