/* isalnum.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler
 */

#ifndef _ISALNUM_IDC_
#define _ISALNUM_IDC_

#include <idcrt\lib\isalpha.idc>
#include <idcrt\lib\isdigit.idc>

/* args: str - input string
 *       idx - index to check for an alphanumeric character
 * returns: 1 if the idx character is an alphanumeric character
 *          0 if not a decimal digit
 *         -1 if idx is out of range
 */
static isalnum(str, idx)
{
	auto rc;
	rc = isalpha(str, idx);
	
	/* is the index out of range? */
	if (rc == -1)
	{
		return -1;
	}
	
	/* if it's not an alpha char... */
	if (rc == 0)
	{
		/* check against the digits */
		rc = isdigit(str, idx);
	}
	
	return rc;
}

#endif

