/* iscsym.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler
 */

#ifndef _ISCSYM_IDC_
#define _ISCSYM_IDC_

#include <idcrt\lib\isalnum.idc>

/* args: str - input string
 *       idx - index to check for a valid symbol character (A-Z, a-z, 0-9, and _ )
 * returns: 1 if the idx character is a valid symbol character
 *          0 if not a decimal digit
 *         -1 if idx is out of range
 */
static iscsym(str, idx)
{
	if (isalnum(str, idx) == 1)
	{
		return 1;
	}
	
	if ("_" == substr(str, idx, idx+1))
	{
		return 1;
	}
		
	return 0;
}

#endif

