/* ishexstr.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _ISHEXSTR_IDC_
#define _ISHEXSTR_IDC_

#include <idcrt/lib/isxdigit.idc>
#include <idcrt/lib/EatLeadWS.idc>

/* args: str - input string to test as a hexdecimal number (the leading "0x" is optional)
 * returns: 1 if the string is a hexdecimal number 
 * 			0 if the string contains non-hexdecimal characters
 */
static ishexstr(str)
{
	auto len, tmp, i, chr;
	
	str = EatLeadWS(str);
	
	tmp = substr(str, 0, 2);
	if ((tmp == "0x") || (tmp == "0X"))
	{
		/* lop off the 0x */
		str = substr(str, 2, -1);
	}

	i=0;	
	len = strlen(str);
	
	if (len == 0)
	{
		/* nothing left...not a hexnumber */
		return 0;
	}

	while (i < len)
	{
		if (0 == isxdigit(str, i))
		{
			/* non hex digit found */
			return 0;
		}
		
		++i;
	}
	
	/* it is a hex number */
	return 1;
}


#endif
