/* isxdigit.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler
 */

#ifndef _ISXDIGIT_IDC_
#define _ISXDIGIT_IDC_

/* args: str - input string
 *       idx - index to check for a hex digit character
 * returns: 1 if the idx character is a hex digit
 *          0 if not a hex digit
 *         -1 if idx is out of range
 */
static isxdigit(str, idx)
{
	auto chr;
	
	chr = substr(str, idx, idx+1);
	if (chr == "")
	{
		return -1;
	}
	
	if (strstr("0123456789ABCDEFabcdef", chr) == -1)
	{
		/* not a hex digit */
		return 0;
	}

	return 1;
}

#endif

