/* makepath.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _MAKEPATH_IDC_
#define _MAKEPATH_IDC_

/* args: drive - the drive letter for the resultant path (can be empty)
 *		 dir - the directory string(can be empty)
 *		 fname - the file root-name string (can be empty)
 *		 ext - the extension string (can be empty)
 * returns: A string composed of the input strings forming a correct Win32 path
 */
static makepath(drive, dir, fname, ext)
{
	auto path;
	auto len;
	
	path = "";
	
	len = strlen(drive);
	if (len != 0)
	{
		path = drive;
		if (substr(drive, len-1, len ) != ":")
		{
			/* add the colon if missing */
			path = path + ":";
		}
	}
	
	len = strlen(dir);
	if (len != 0)
	{
		auto lastchr;
		
		/* insert the dir and the trailing slash if and only if it
			doesn't already exist and the dir is non-empty */
		path = path + dir;
		
		lastchr = substr(dir, len-1, len );
		
		if ((lastchr != "\\") && (lastchr != "/"))
		{
			/* add the trailing slash if missing */
			path = path + "\\";
		}
	}
	
	len = strlen(fname);
	if (len != 0)
	{
		path = path + fname;
	}
	
	len = strlen(ext);
	if (len != 0)
	{
		/* check for the leading period */
		if (substr(ext, 0, 1) != ".")
		{
			path = path + ".";
		}
		
		path = path + ext;
	}
	
	return path;
}


#endif

