/* makepathv.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _MAKEPATHV_IDC_
#define _MAKEPATHV_IDC_

#include <idcrt\lib\makepath.idc>


#ifndef PATH_DRIVE_IDX
#define PATH_DRIVE_IDX	(0)
#define PATH_DIR_IDX	(1)
#define PATH_FNAME_IDX	(2)
#define PATH_EXT_IDX	(3)
#endif



/* args: pathArray - user-allocated array containing the component parts of the
 					path to be constructed.
 * returns: A string composed of the input strings forming a correct Win32 path
 * NOTE: the user is responsible for creating and destroying the path array
 */
static makepathv(pathArray)
{
	auto drive, dir, fname, ext;
	
	drive = GetArrayElement(AR_STR, pathArray, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, pathArray, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, pathArray, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, pathArray, PATH_EXT_IDX);
	
	return makepath(drive, dir, fname, ext);
}

#endif

