/* compactstrarray.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */
#ifndef _SPLITSTRING_IDC_
#define _SPLITSTRING_IDC_

/* args: inStr - input string to be split
 *		 splitChars - list of characters to split on
 *		 outArray - user-allocated array to receive the substrings
 * returns: the number of substrings created
 */
static splitstring(inStr, splitChars, outArray)
{
	auto sIdx;	/* string iterator index */
	auto aIdx;  /* array index */
	auto startIdx; /* first index after last split */
	auto inStrLen; /* total string length */
	
	/* foreach char in inStr, find it in splitChars */
	aIdx = 0;
	sIdx = 0;
	startIdx = 0;
	
	inStrLen = strlen(inStr);
	
	while(sIdx <= inStrLen)
	{
		/* last character or a split character */
		if ((sIdx == inStrLen) || ( -1 != strstr(splitChars, substr(inStr, sIdx, sIdx+1)) ))
		{
			auto newStr;
			
			/* this character is a split char */
			newStr = substr(inStr, startIdx, sIdx);
			startIdx = sIdx+1;
		
			/* if found, then shove that string into outArray */	
			SetArrayString(outArray, aIdx, newStr);

			aIdx = aIdx + 1;
		}
		
		sIdx = sIdx + 1;
	}
	
	return aIdx;
}

#endif

