/* strnicmp.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _STRNICMP_IDC_
#define _STRNICMP_IDC_

#include <idcrt\lib\strupr.idc>

/* args: str1, str2 - input strings to compare disregarding case
 *		 count - the maximum number of characters to compare in the two strings
 * returns: 0 if the strings match up to 'count' characters disregarding case
 *			1 if 'str1' is greater than 'str2'
 *			-1 if 'str1' is less than 'str2'
 */
static strnicmp(str1, str2, count)
{
	str1 = strupr(substr(str1, 0, count));
	str2 = strupr(substr(str2, 0, count));
	
	if (str1 == str2)
	{
		return 0;
	}
	else if (str1 > str2)
	{
		return 1;
	}

	return -1;
}

#endif

