/* strrstr.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _STRRSTR_IDC_
#define _STRRSTR_IDC_

/* find the last instance of the source string */
/* args: str - input string to be made completely lower case
 *		 strfrag - input string to find in 'str'
 * returns: -1 if 'strfrag' isn't found in 'str'
 *			the index of the last instance of 'strfrag' found in the 'str'
 */
static strrstr(str, strfrag)
{
	/* this might not be the most efficient way to do this for long strings, but
	at least we get to use the built-in strstr command which is likely faster than
	doing our own matching in script */

	auto idx, lastIdx;
	
	lastIdx = -1;
	idx = 0;
	
	
	while (idx != -1)
	{
		idx = strstr(str, strfrag);
		lastIdx = lastIdx + idx + 1;
		str = substr(str, idx+1, -1);
	}
	
	return lastIdx;
}

#endif

