/* strtitle.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _STRTITLE_IDC_
#define _STRTITLE_IDC_

/* args: str - input string to be made completely lower case
 * returns: the lower-case version of the input string
 */
static strtitle(str)
{
	auto chr;
	auto idx;
	auto pos;
	auto len;
	auto outStr;
	
	auto caseMode;
	
	outStr = "";
	caseMode = 0;		/* 0 - next letter is uppercase */
					/* 1 - next letter is lowercase */
	
	len = strlen(str);
	pos = 0;
	
	while(pos  < len)
	{
		chr = substr(str, pos, pos+1);
	
		if (caseMode == 0)
		{
			/* next character is to be upper case */
			
			/* convert to an ascii index */
			idx = strstr("abcdefghijklmnopqrstuvwxyz", chr);

			if (idx != -1)
			{
				chr = substr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", idx, idx+1);
			}

			if (strstr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", chr) != -1)
			{
				/* we wanted a upper case char and we got one.
				 * go to lower-case mode
				 */
				caseMode = 1;
			}
		}
		else
		{
			/* next character is to be lower case */
			
			/* convert to an ascii index */
			idx = strstr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", chr);

			if (idx != -1)
			{
				chr = substr("abcdefghijklmnopqrstuvwxyz", idx, idx+1);
			}

			if (strstr("abcdefghijklmnopqrstuvwxyz", chr) == -1)
			{
				/* we wanted a lower case char and we didn't get one.
				 * this means that we got a symbol. The next char should
				 * be upper case
				 */
				caseMode = 0;
			}
		}
		
	

		/* add the converted character on to the output string */		
		outStr = outStr + chr;

		pos = pos + 1;
	}
	
	return outStr;
}

#endif
