/* unlink.idc
 * 
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#ifndef _UNLINK_H_
#define _UNLINK_H_

#include <idcrt\lib\EatLeadWS.idc>
#include <idcrt\lib\EatTailWS.idc>
#include <idcrt\lib\FindNextWS.idc>
#include <idcrt\lib\spawn.idc>


/* args: filename - path to a file to be deleted
 * 		returns - The OS-returned success code for the operation
 */
static unlink(filename)
{
	filename = EatLeadWS(filename);
	filename = EatTailWS(filename);
	
	if (-1 != FindNextWS(filename))
	{
		/* there is embedded whitespace in the filename so we should quote the string */

		auto len;
		len = strlen(filename);
		if (len != 0)
		{
			if ((substr(filename, 0, 1) != "\"") || (substr(filename, len-1, len)!= "\""))
			{
				filename = "\"" + filename + "\"";
			}
		}
	}
	
	return spawn("del "+filename);
}

#endif


