/* test.idc
 * 
 * This is purely an experimental script to test the other scritps
 *
 * Permission to modify and use this code in your own programs is
 * hereby granted provided under the following terms:
 * 1) This notice and all credits, licenses, and mindless blather remain intact.
 * 2) If this is used for professional purposes, the author will be notified as
 *    a courtesy. (ok, I'm curious)
 * 3) Bugfixes and changes to the code or documentaion are freely given back to
 *    the author so they may be shared with everyone.
 * 4) This won't be used to make IDA Pro do evil things.
 *
 * Copyright (c) 2003 Jason Weiler.
 */

#include <idc.idc>
#include <idcrt\ctype.idc>
#include <idcrt\stdio.idc>
#include <idcrt\stdlib.idc>
#include <idcrt\string.idc>


#include <idcrt\process.idc>
#include <idcrt\whitespace.idc>

static main(void)
{
	Message("makepath...");
	if (test_makepath() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	Message("makepathv...");
	if (test_makepathv() == 0)
		Message("passed\n");
	else
		Message("failed\n");

	Message("splitpathv...");
	if (test_splitpathv() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	
	
	Message("toupper...");
	if (test_toupper() == 0)
		Message("passed\n");
	else
		Message("failed\n");
		
	Message("tolower...");
	if (test_tolower() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	Message("strupr/dnstr...");
	if (test_struprlwr() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	
	Message("strXcmp...");
	if (test_strXcmp() == 0)
		Message("passed\n");
	else
		Message("failed\n");

	Message("strrstr...");
	if (test_strrstr() == 0)
		Message("passed\n");
	else
		Message("failed\n");

	Message("ctype...");
	if (test_ctype() == 0)
		Message("passed\n");
	else
		Message("failed\n");
		
	Message("totitle...");
	if (test_strtitle() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	Message("stdio...");
	if (test_stdio() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	Message("ishexstr...");
	if (test_ishexstr() == 0)
		Message("passed\n");
	else
		Message("failed\n");

	Message("abs...");
	if (test_abs() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	Message("test_whitespace...");
	if (test_whitespace() == 0)
		Message("passed\n");
	else
		Message("failed\n");

	Message("test_split_comp...");
	if (test_split_comp() == 0)
		Message("passed\n");
	else
		Message("failed\n");
	
	
	return 0;
}


static test_makepath()
{	
	auto path;
	
	path = makepath("D", "\\IDA450\\idc", "test", "idc");
//	Message(path+"\n");
	if (path != "D:\\IDA450\\idc\\test.idc")
	{
		Message("Error in Makepath!\n");
		return -1;
	}

	path = makepath("", "\\IDA450\\idc\\", "test", ".idc");	
//	Message(path+"\n");
	if (path != "\\IDA450\\idc\\test.idc")
	{
		Message("Error in Makepath!\n");
		return -1;
	}
		
	path = makepath("E:", "\\", "test", "");
//	Message(path+"\n");
	if (path != "E:\\test")
	{
		Message("Error in Makepath!\n");
		return -1;
	}
	
	return 0;
}

static test_makepathv()
{	
	auto path;
	auto arrayId;
	
	arrayId = GetArrayId("TestMakepathv_Array");
	if (arrayId != -1)
	{
		DeleteArray(arrayId);
		arrayId = -1;
	}
	
	arrayId = CreateArray("TestMakepathv_Array");
	
	if (arrayId == -1)
	{
		Message("Failed to create MakePathv array!!\n");
		return -1;
	}
	
	SetArrayString(arrayId, PATH_DIR_IDX, "\\IDA450\\idc");
	SetArrayString(arrayId, PATH_FNAME_IDX, "test");
	
	path = makepathv(arrayId);
	if (path != "\\IDA450\\idc\\test")
	{
		Message("Error in Makepathv!\n");
		DeleteArray(arrayId);
		return -1;
	}

	SetArrayString(arrayId, PATH_DRIVE_IDX, "D");
	SetArrayString(arrayId, PATH_EXT_IDX, "idc");

	path = makepathv(arrayId);
	if (path != "D:\\IDA450\\idc\\test.idc")
	{
		Message("Error in makepathv!\n");
		DeleteArray(arrayId);
		return -1;
	}
	DeleteArray(arrayId);
	
	return 0;
}

static test_splitpathv()
{	
	auto path;
	auto arrayId;
	auto drive;
	auto dir;
	auto fname;
	auto ext;
	
	arrayId = GetArrayId("TestSplitpathv_Array");
	if (arrayId != -1)
	{
		DeleteArray(arrayId);
		arrayId = -1;
	}
	
	arrayId = CreateArray("TestSplitpathv_Array");
	
	if (arrayId == -1)
	{
		Message("Failed to create SplitPathv array!!\n");
		return -1;
	}
	
	path = "c:\\simplepath.ext";
	splitpathv(path, arrayId);
	
	drive = GetArrayElement(AR_STR, arrayId, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, arrayId, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, arrayId, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, arrayId, PATH_EXT_IDX);
	
	if ((drive != "c:") || (dir != "\\") || (fname != "simplepath") || (ext != ".ext"))
	{
		Message("Error in Splitpathv1! '%s' -> {'%s' '%s' '%s' '%s'}\n" path, drive, dir, fname, ext);
		DeleteArray(arrayId);
		return -1;
	}

	/* ************* */

	path = "d:\\simplepath";
	splitpathv(path, arrayId);

	drive = GetArrayElement(AR_STR, arrayId, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, arrayId, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, arrayId, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, arrayId, PATH_EXT_IDX);
	
	if ((drive != "d:") || (dir != "\\") || (fname != "simplepath") || (ext != ""))
	{
		Message("Error in Splitpathv2! '%s' -> {'%s' '%s' '%s' '%s'}\n" path, drive, dir, fname, ext);
		DeleteArray(arrayId);
		return -1;
	}

	/* ************* */

	path = "e:\\simplepath\\";
	splitpathv(path, arrayId);

	drive = GetArrayElement(AR_STR, arrayId, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, arrayId, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, arrayId, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, arrayId, PATH_EXT_IDX);
	
	if ((drive != "e:") || (dir != "\\simplepath\\") || (fname != "") || (ext != ""))
	{
		Message("Error in Splitpathv3! '%s' -> {'%s' '%s' '%s' '%s'}\n" path, drive, dir, fname, ext);
		DeleteArray(arrayId);
		return -1;
	}


	/* ************* */

	path = "\\simplepath\\file.bob";
	splitpathv(path, arrayId);

	drive = GetArrayElement(AR_STR, arrayId, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, arrayId, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, arrayId, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, arrayId, PATH_EXT_IDX);
	
	if ((drive != "") || (dir != "\\simplepath\\") || (fname != "file") || (ext != ".bob"))
	{
		Message("Error in Splitpathv4! '%s' -> {'%s' '%s' '%s' '%s'}\n" path, drive, dir, fname, ext);
		DeleteArray(arrayId);
		return -1;
	}

	/* ************* */

	path = "simplepath";
	splitpathv(path, arrayId);

	drive = GetArrayElement(AR_STR, arrayId, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, arrayId, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, arrayId, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, arrayId, PATH_EXT_IDX);
	
	if ((drive != "") || (dir != "") || (fname != "simplepath") || (ext != ""))
	{
		Message("Error in Splitpathv5! '%s' -> {'%s' '%s' '%s' '%s'}\n" path, drive, dir, fname, ext);
		DeleteArray(arrayId);
		return -1;
	}

	/* ************* */

	path = "Z:\\simplepath\\another path/yet another_damn path/noafile.bob\\zeek.baz";
	splitpathv(path, arrayId);

	drive = GetArrayElement(AR_STR, arrayId, PATH_DRIVE_IDX);
	dir = GetArrayElement(AR_STR, arrayId, PATH_DIR_IDX);
	fname = GetArrayElement(AR_STR, arrayId, PATH_FNAME_IDX);
	ext = GetArrayElement(AR_STR, arrayId, PATH_EXT_IDX);
	
	if ((drive != "Z:") || (dir != "\\simplepath\\another path/yet another_damn path/noafile.bob\\")
		|| (fname != "zeek") || (ext != ".baz"))
	{
		Message("Error in Splitpathv6! '%s' -> {'%s' '%s' '%s' '%s'}\n" path, drive, dir, fname, ext);
		DeleteArray(arrayId);
		return -1;
	}

	DeleteArray(arrayId);
	
	return 0;
}

static test_toupper()
{
	auto chr;
	
	chr = toupper("a", 0);
	if (chr != "A")
	{
		Message("Error in toupper test #1!\n");
		return -1;
	}
	
	
	chr = toupper("+", 0);
	if (chr != "+")
	{
		Message("Error in toupper test #2!\n");
		return -1;
	}
	
	
	chr = toupper("A", 0);
	if (chr != "A")
	{
		Message("Error in toupper test #3!\n");
		return -1;
	}
	
	chr = toupper("xyZ", 0);
	if (chr != "X")
	{
		Message("Error in toupper test #4!\n");
		return -1;
	}

	return 0;
}


static test_tolower()
{
	auto chr;
	
	chr = tolower("A", 0);
	if (chr != "a")
	{
		Message("Error in tolower test #1!\n");
		return -1;
	}
	
	chr = tolower("a", 4);
	if (chr != -1)
	{
		Message("Error in tolower test #2!\n");
		return -1;
	}
	
	chr = tolower("123", 2);
	if (chr != "3")
	{
		Message("Error in tolower test #3!\n");
		return -1;
	}
	
	chr = tolower("m", 0);
	if (chr != "m")
	{
		Message("Error in tolower test #5!\n");
		return -1;
	}
	
	chr = tolower("XyZ", 0);
	if (chr != "x")
	{
		Message("Error in tolower test #6!\n");
		return -1;
	}

	return 0;
}


static test_struprlwr()
{
	auto str;
	
	str = strupr("This1is#a$mixed%caSE)STRING ?WiTh309480293 Garbage\n");
	if (str != "THIS1IS#A$MIXED%CASE)STRING ?WITH309480293 GARBAGE\n")
	{
		Message("Error in strupr test #1!\n");
		return -1;
	}

	str = strlwr("This1is#a$mixed%caSE)STRING ?WiTh309480293 Garbage\n");
	if (str != "this1is#a$mixed%case)string ?with309480293 garbage\n")
	{
		Message("Error in strlwr test #2!\n");
		return -1;
	}

}


static test_strXcmp()
{
	if (stricmp("abC", "AbC") != 0)
	{
		Message("Error in stricmp test #1!\n");
		return -1;
	}

	if (stricmp("abCD", "AbC") != 1)
	{
		Message("Error in stricmp test #2!\n");
		return -1;
	}

	if (stricmp("abCD", "ZbC") != -1)
	{
		Message("Error in stricmp test #3!\n");
		return -1;
	}



	if (strnicmp("Fuzzy Wuzzy Wuz a Woman", "FuZZy WuZZy Wuzn't a Man", 11) != 0)
	{
		Message("Error in strnicmp test #1!\n");
		return -1;
	}

	if (strncmp("Fuzzy Wuzzy Wuz a Woman", "fuzzy Wuzzy Wuzn't a Man", 11) != -1)
	{
		Message("Error in strncmp test #1!\n");
		return -1;
	}

	if (strncmp("Fuzzy Wuzzy Wuz a Woman", "FUzzy Wuzzy Wuzn't a Man", 11) != 1)
	{
		Message("Error in strncmp test #2!\n");
		return -1;
	}

	return 0;
}

static test_ctype()
{
	auto string;
	
	string = "Diss is_@ t3st STRaNG\n";

	/* ISLOWER */	
	if (isupper(string, 0) != 1)
	{
		Message("Error in isupper Test #1\n");
		return -1;
	}

	if (isupper(string, 2) != 0)
	{
		Message("Error in isupper Test #2\n");
		return -1;
	}

	if (isupper(string, 4) != 0)
	{
		Message("Error in isupper Test #3\n");
		return -1;
	}

	if (isupper(string, 8) != 0)
	{
		Message("Error in isupper Test #4\n");
		return -1;
	}
	
	if (isupper(string, 11) != 0)
	{
		Message("Error in isupper Test #5\n");
		return -1;
	}

	/* ISLOWER */
	if (islower(string, 0) != 0)
	{
		Message("Error in islower Test #1\n");
		return -1;
	}

	if (islower(string, 2) != 1)
	{
		Message("Error in islower Test #2\n");
		return -1;
	}

	if (islower(string, 4) != 0)
	{
		Message("Error in islower Test #3\n");
		return -1;
	}

	if (islower(string, 8) != 0)
	{
		Message("Error in islower Test #4\n");
		return -1;
	}
	
	if (islower(string, 11) != 0)
	{
		Message("Error in islower Test #5\n");
		return -1;
	}

	/* ISSPACE */
	if (isspace(string, 4) != 1)
	{
		Message("Error in isspace Test #1\n");
		return -1;
	}
	
	if (isspace(string, 21) != 1)
	{
		Message("Error in isspace Test #2\n");
		return -1;
	}
	
	if (isspace(string, 22) != -1)
	{
		Message("Error in isspace Test #3\n");
		return -1;
	}

	if (isspace(string, 3) != 0)
	{
		Message("Error in isspace Test #4\n");
		return -1;
	}


	/* ISDIGIT */
	if (isdigit(string, 11) != 1)
	{
		Message("Error in isdigit Test #1\n");
		return -1;
	}
	
	if (isdigit(string, 12) != 0)
	{
		Message("Error in isdigit Test #2\n");
		return -1;
	}

	/* ISXDIGIT */
	if (isxdigit(string, 11) != 1)
	{
		Message("Error in isxdigit Test #1\n");
		return -1;
	}

	if (isxdigit(string, 18) != 1)
	{
		Message("Error in isxdigit Test #2\n");
		return -1;
	}

	if (isxdigit(string, 0) != 1)
	{
		Message("Error in isxdigit Test #3\n");
		return -1;
	}

	if (isxdigit(string, 39) != -1)
	{
		Message("Error in isxdigit Test #4\n");
		return -1;
	}

	if (isxdigit(string, 1) != 0)
	{
		Message("Error in isxdigit Test #5\n");
		return -1;
	}


	/* ISALPHA */
	if (isalpha(string, 0) != 1)
	{
		Message("Error in isalpha Test #1\n");
		return -1;
	}

	if (isalpha(string, 4) != 0)
	{
		Message("Error in isalpha Test #2\n");
		return -1;
	}

	if (isalpha(string, 8) != 0)
	{
		Message("Error in isalpha Test #3\n");
		return -1;
	}

	if (isalpha(string, 11) != 0)
	{
		Message("Error in isalpha Test #4\n");
		return -1;
	}

	if (isalpha(string, 21) != 0)
	{
		Message("Error in isalpha Test #5\n");
		return -1;
	}

	if (isalpha(string, 20) != 1)
	{
		Message("Error in isalpha Test #6\n");
		return -1;
	}

	/* ISALNUM */
	if (isalnum(string, 0) != 1)
	{
		Message("Error in isalnum Test #1\n");
		return -1;
	}

	if (isalnum(string, 4) != 0)
	{
		Message("Error in isalnum Test #2\n");
		return -1;
	}

	if (isalnum(string, 8) != 0)
	{
		Message("Error in isalnum Test #3\n");
		return -1;
	}

	if (isalnum(string, 11) != 1)
	{
		Message("Error in isalnum Test #4\n");
		return -1;
	}

	if (isalnum(string, 21) != 0)
	{
		Message("Error in isalnum Test #5\n");
		return -1;
	}

	if (isalnum(string, 20) != 1)
	{
		Message("Error in isalnum Test #6\n");
		return -1;
	}

	if (isalnum(string, 22) != -1)
	{
		Message("Error in isalnum Test #7\n");
		return -1;
	}

	if (iscsym(string, 1) != 1)
	{
		Message("Error in iscsym Test #1\n");
		return -1;
	}

	if (iscsym(string, 4) != 0)
	{
		Message("Error in iscsym Test #2\n");
		return -1;
	}

	if (iscsym(string, 7) != 1)
	{
		Message("Error in iscsym Test #3\n");
		return -1;
	}

	if (iscsym(string, 8) != 0)
	{
		Message("Error in iscsym Test #4\n");
		return -1;
	}

	if (iscsym(string, 9) != 0)
	{
		Message("Error in iscsym Test #5\n");
		return -1;
	}

	if (iscsym(string, 11) != 1)
	{
		Message("Error in iscsym Test #6\n");
		return -1;
	}

	if (iscsymf(string, 2) != 1)
	{
		Message("Error in iscsymf Test #1\n");
		return -1;
	}

	if (iscsymf(string, 4) != 0)
	{
		Message("Error in iscsymf Test #2\n");
		return -1;
	}

	if (iscsymf(string, 7) != 1)
	{
		Message("Error in iscsymf Test #3\n");
		return -1;
	}

	if (iscsymf(string, 8) != 0)
	{
		Message("Error in iscsymf Test #4\n");
		return -1;
	}

	if (iscsymf(string, 9) != 0)
	{
		Message("Error in iscsymf Test #5\n");
		return -1;
	}

	if (iscsymf(string, 11) != 0)
	{
		Message("Error in iscsymf Test #6\n");
		return -1;
	}

	return 0;
}

static test_strtitle()
{
	auto str;
	
	str = "Thisis a sTring_that*$)(shOULDBe_Titlized.";
	str = strtitle(str);

	if (str != "Thisis A String_That*$)(Shouldbe_Titlized.")
	{
		Message("Error in totitle Test #1\n");
		return -1;
	}
	
	return 0;
}

static test_stdio()
{
	auto filename, hFile, rc;
	
	filename = "fakef ilename.foo";
	
	hFile = fopen(filename, "w");
	
	writestr(hFile, "test string");
	
	rc = feof(hFile);
	if (rc != 1)
	{
		Message("Error in feof!! Test #1\n");
		return -1;
	}

	fseek(hFile, 0, 0);

	rc = feof(hFile);
	if (rc != 0)
	{
		Message("Error in feof!! Test #2\n");
		return -1;
	}
	
	fclose(hFile);
	
	rc = unlink(filename);
	if (rc != 0)
	{
		Message("Error in unlink!! Test #1\n");
		return -1;
	}
	
	filename = "anotherfakename.fake";
	hFile = fopen(filename, "w");
	
	writestr(hFile, "test string");

	fclose(hFile);
	
	rc = fileexists(filename);
	if (rc != 1)
	{
		Message("Error in fileexists!! Test #1\n");
		return -1;
	}
	
	rc = unlink(filename);
	if (rc != 0)
	{
		Message("Error in unlink!! Test #2\n");
		return -1;
	}

	rc = fileexists(filename);
	if (rc != 0)
	{
		Message("Error in fileexists!! Test #2\n");
		return -1;
	}


	rc = unlink(filename);
	
	/* del failure is actually 1 */
	if (rc == 0)
	{
		Message("Error in unlink!! Test #3\n");
		return -1;
	}
	
	return 0;
}

static test_ishexstr()
{
	auto rc;

	rc = ishexstr("0xDEAdbEEf");
	if (rc != 1)
	{
		Message("Error in ishexstr!! Test #1\n");
		return -1;
	}
	
	rc = ishexstr("DEAdbEEf");
	if (rc != 1)
	{
		Message("Error in ishexstr!! Test #2\n");
		return -1;
	}
	
	rc = ishexstr(" \r\n\t DEAdb33f \r\t\n ");
	if (rc != 0)
	{
		Message("Error in ishexstr!! Test #3\n");
		return -1;
	}

	rc = ishexstr("DEADCODE");
	if (rc != 0)
	{
		Message("Error in ishexstr!! Test #4\n");
		return -1;
	}

	rc = ishexstr("");
	if (rc != 0)
	{
		Message("Error in ishexstr!! Test #4\n");
		return -1;
	}

	return 0;
}

static test_abs()
{
	auto result;
	
	result = abs(1);
	if (result != 1)
	{
		Message("Error in abs!! Test #1\n");
		return -1;
	}

	result = abs(0);
	if (result != 0)
	{
		Message("Error in abs!! Test #2\n");
		return -1;
	}

	result = abs(-100);
	if (result != 100)
	{
		Message("Error in abs!! Test #3\n");
		return -1;
	}
	
	return 0;
}

static test_strrstr()
{
	auto str;
	auto frag;
	auto rc;
	
	str = "test  this string is a teststring for this test";
	
	frag = "test";
	rc = strrstr(str, frag);
	if (rc != 43)
	{
		Message("Error in strrstr!! Test #1\n");
		return -1;
	}

	frag = "this";
	rc = strrstr(str, frag);
	if (rc != 38)
	{
		Message("Error in strrstr!! Test #2\n");
		return -1;
	}

	frag = "test ";
	rc = strrstr(str, frag);
	if (rc != 0)
	{
		Message("Error in strrstr!! Test #3\n");
		return -1;
	}

	frag = "test:";
	rc = strrstr(str, frag);
	if (rc != -1)
	{
		Message("Error in strrstr!! Test #4\n");
		return -1;
	}

	return 0;
}

static test_whitespace()
{
	auto str;
	auto tmpstr;
	auto result;
	
	str = "    t e s t   ";
	
	result = EatLeadWS(str);
	if (result != "t e s t   ")
	{
		Message("Error in EatLeadWS!! Test #1\n");
		return -1;
	}
	
	result = EatLeadWS(EatTailWS(str));
	if (result != "t e s t")
	{
		Message("Error in Eat(Lead/Tail)WS!! Test #2\n");
		return -1;
	}
	
	result = FindNextWS(str);
	if (result != 0)
	{
		Message("Error in FindNextWS!! Test #1\n");
		return -1;
	}
	
	tmpstr = EatLeadWS(str);
	tmpstr = substr(tmpstr, FindNextWS(tmpstr), -1);
	result = FindNextWS(tmpstr);
	if (tmpstr != " e s t   ")
	{
		Message("Error in FindNextWS!! Test #2\n");
		return -1;
	}
	
	return 0;
}

static test_split_comp()
{
	auto i;
	auto arrayID;
	auto idx;
	

	DeleteArray(GetArrayId("myarray"));
	arrayID = CreateArray("myarray");
	
	i = splitstring("This \t\t\tis a\t     string of words\n\nend", "\t \n", arrayID);
	
	
	if ((i != 16)
		|| ("This" != GetArrayElement(AR_STR, arrayID, 0 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 1 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 2 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 3 ))
		|| ("is" != GetArrayElement(AR_STR, arrayID, 4 ))
		|| ("a" != GetArrayElement(AR_STR, arrayID, 5 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 6 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 7 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 8 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 9 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 10 ))
		|| ("string" != GetArrayElement(AR_STR, arrayID, 11 ))
		|| ("of" != GetArrayElement(AR_STR, arrayID, 12 ))
		|| ("words" != GetArrayElement(AR_STR, arrayID, 13 ))
		|| ("" != GetArrayElement(AR_STR, arrayID, 14 ))
		|| ("end" != GetArrayElement(AR_STR, arrayID, 15 )) )
	{
		Message("Error in splitstring!! Test #1\n");
		return -1;
	}
	
	i= compactstrarray(arrayID, 1);

	if ((i != 7)
		|| ("This" != GetArrayElement(AR_STR, arrayID, 0 ))
		|| ("is" != GetArrayElement(AR_STR, arrayID, 1 ))
		|| ("a" != GetArrayElement(AR_STR, arrayID, 2 ))
		|| ("string" != GetArrayElement(AR_STR, arrayID, 3 ))
		|| ("of" != GetArrayElement(AR_STR, arrayID, 4 ))
		|| ("words" != GetArrayElement(AR_STR, arrayID, 5 ))
		|| ("end" != GetArrayElement(AR_STR, arrayID, 6 )) )
	{
		Message("Error in compactstrarray!! Test #1\n");
		return -1;
	}

	
	idx = GetFirstIndex(AR_STR, arrayID);
	while (idx != -1)
	{
		DelArrayElement(AR_STR, arrayID, idx);
		idx = GetNextIndex(AR_STR, arrayID, idx);
	}

	i = splitstring("This \t\t\tis a\t     string of words\n\nend", "s", arrayID);

	if ((i != 5)
		|| ("Thi" != GetArrayElement(AR_STR, arrayID, 0 ))
		|| (" \t\t\ti" != GetArrayElement(AR_STR, arrayID, 1 ))
		|| (" a\t     " != GetArrayElement(AR_STR, arrayID, 2 ))
		|| ("tring of word" != GetArrayElement(AR_STR, arrayID, 3 ))
		|| ("\n\nend" != GetArrayElement(AR_STR, arrayID, 4 )) )
	{
		Message("Error in splitstring!! Test #2\n");
		return -1;
	}

	i= compactstrarray(arrayID, 1);

	if ((i != 5)
		|| ("Thi" != GetArrayElement(AR_STR, arrayID, 0 ))
		|| (" \t\t\ti" != GetArrayElement(AR_STR, arrayID, 1 ))
		|| (" a\t     " != GetArrayElement(AR_STR, arrayID, 2 ))
		|| ("tring of word" != GetArrayElement(AR_STR, arrayID, 3 ))
		|| ("\n\nend" != GetArrayElement(AR_STR, arrayID, 4 )) )
	{
		Message("Error in compactstrarray!! Test #2\n");
		return -1;
	}
	
	DeleteArray(arrayID);
	
	return 0;
}
